#include <io.h>
#include <math.h>
#include <interrupt.h>
#include <sig-avr.h>
#include <progmem.h>

#include "motor.h"
#include "wait.h"
#include <stdlib.h>
#include <string.h>

#include "ScriptOhio.h"
#include "ScriptGators.h"
#include "ADC.h"
#include "LED.h"
#include "UART.h"
#include "marker.h"
#include "Camera.h"
#include "Music.h"
#include "FindMascot.h"


int main(void)
{
	Music_init();
	MOTOR_init();
	ADC_init();
	UART_init();
	Camera_init();
	
	outp(0xff,DDRC);
	
	unsigned char IR_value;
	unsigned char BumpSensor;
	unsigned char BumpSensor2;
	unsigned char rdata;
	
	IR_value = ADC_getreading(0);
	BumpSensor = ADC_getreading(2);
	BumpSensor2 = ADC_getreading(3);
	
	
	while (1)
	{
		BumpSensor = ADC_getreading(2);
		
		while (BumpSensor > 50)
		{
			BumpSensor = ADC_getreading(2);
		}
		
		FindMas();

		
		//blink();
		
		rdata = ParseString();  //500;
		
		int walldist;
		
		walldist = FindWall();
		
		UART_Printfu16(walldist);
		
	
		if (rdata < 223) 
		{
			motor_run(38, -954, 1000);
			motor_run(25, -963,	1000);  //turn
			motor_run(38, -954, 1000);
		
			Play_UF();
			wait(1000);
			if (walldist == 1)
			{
				ScriptGators();
			}
			else if (walldist == 2)
			{
				ScriptGators2();
			}
			else
			{
				ScriptGators3();
			}
			Play_UF();
		}
		else
		{
		//	motor_run(38, -954, 1000);
		//	motor_run(0,0, 50);
			motor_run(25, -972,	1100);	//spin
			motor_run(54, -970,	1000);
			Play_OSU();
			wait(1000);
			if (walldist == 1)
			{
				ScriptOhio();
			}
			else if (walldist == 2)
			{
				ScriptOhio2();
			}
			else
			{
				ScriptOhio3();
			}
			Play_OSU();
		}
		cbi(PORTC,PC1);		
		
	}	
}
//}
	
/*
	wait(100);
	while (BumpSensor < 50)
	{
		BumpSensor = ADC_getreading(2);
		
	}
	wait(500);

	outp(0xff,DDRC);
	
	while (1) {
		IR_value = ADC_getreading(0);
		BumpSensor = ADC_getreading(2);
		BumpSensor2 = ADC_getreading(3);

		LED(IR_value);
		LED(BumpSensor);
		
		while ((BumpSensor > 50) && (BumpSensor2 > 50))
		{
			BumpSensor = ADC_getreading(2);
			BumpSensor2 = ADC_getreading(3);

		}
		
		if (BumpSensor < 50)
		{
			Play_OSU();
			ScriptOhio();
		}
		else 
		{
			Play_UF();
			ScriptGators();
		}
	
		cbi(PORTC,PC1);
	}
*/
		

		
//		while ((BumpSensor > 50) || (BumpSensor2 > 50))
//		{
//			BumpSensor = ADC_getreading(2);
//			BumpSensor2 = ADC_getreading(3);
//
//		}

			
		//	sbi(PORTC,PC1);
		//	BumpSensor = ADC_getreading(2);
		//	__outw(BumpSensor, UDR);
		//	EOL();
			
		
		//	cbi(PORTC,PC1);
		
//		UART_PrintfProgStr(IR_value0);
//    		outp( PRG_RDB(IR_value), UDR );
//		PRINT("IR_value= ");
//		UART_Printfu16(IR_value0);	
//		PRINT("  BumpSensor= ");				
//		UART_Printfu16(BumpSensor);
//		EOL();
		
//		}

//}