#include <io.h>
#include <math.h>
#include "motor.h"
#include "wait.h"

void MOTOR_init(void)
{
	__outw(SERVO_STOP, OCR1AL);	//5 -right						// set PWM to 10% duty cycle on channel A 
	__outw(SERVO_STOP, OCR1BL);	//4 -left						// set PWM to 10% duty cycle on channel B 
	outp((1<<COM1A1) | (1<<COM1B1) | (1<<PWM10) | (1<<PWM11), TCCR1A);		// set output compare OC1A/OC1B clear on compare match, 
	outp((1<<CS11) | (1<<CS10), TCCR1B);						// store prescaler Clk(I/O)/8. 
	sbi(DDRD, PD4); //left
	sbi(DDRD, PD5); //right
	
}

void motor_run(int leftmotor, int rightmotor, int waittime)
{
	__outw(leftmotor, OCR1AL);
	__outw(rightmotor, OCR1BL);
	
	//unsigned char totalwait;
	//totalwait = waittime * waitlength;
	
	wait(waittime);
}
	

void SERVO_speed(int mot_num, int speed){
	unsigned short SERVO_SPEED;		
	
	if(speed > FULL_RIGHT)
		speed = 100;
	else if(speed < FULL_LEFT)
		speed = -100;

	if(mot_num == 0){		
		if(speed == 0)								// if speed = 0 then stop motor
			SERVO_SPEED = SERVO_STOP;
		else if( speed >= FULL_RIGHT) 						// if speed = FULL_RIGHT then full speed to the right
			SERVO_SPEED = SERVO_RIGHT;
		else if( speed <= FULL_LEFT) 						// if speed = FULL_LEFT then full speed to the left
			SERVO_SPEED = SERVO_LEFT;
		else	 								// if speed is less than 0 calculate percentage
			SERVO_SPEED = SERVO_STOP + speed;
		__outw(SERVO_SPEED, OCR1BL);
	}//if
	else if(mot_num == 1){
		speed = -speed;
		
		if(speed == 0)								// if speed = 0 then stop motor
			SERVO_SPEED = SERVO_STOP;
		else if( speed >= FULL_RIGHT) 						// if speed = FULL_RIGHT then full speed to the right
			SERVO_SPEED = SERVO_RIGHT;
		else if( speed <= FULL_LEFT) 						// if speed = FULL_LEFT then full speed to the left
			SERVO_SPEED = SERVO_LEFT;
		else	 								// if speed is less than 0 calculate percentage
			SERVO_SPEED = SERVO_STOP + speed;
	
		__outw(SERVO_SPEED, OCR1AL);

	}//else if
	
	return;
}


void MOTOR_speed(int leftspeed, int rightspeed){
	SERVO_speed(LEFT_MOTOR,-leftspeed);
	SERVO_speed(RIGHT_MOTOR, -rightspeed);

}//MOTOR_speed